From b6614db28b1c81ec2e9c980ec541720c3d53cad7 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:17:48 +0000
Subject: [PATCH 797/2232] Add symlink_dir to fs lib


To be used in cxx-build refactor.

---

diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 82cb5cc..c554ef0 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -105,7 +105,7 @@ fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
 }
 
 #[cfg(unix)]
-use self::fs::symlink as symlink_or_copy;
+use self::fs::symlink_file as symlink_or_copy;
 
 #[cfg(windows)]
 fn symlink_or_copy(src: &Path, dst: &Path) -> Result<()> {
diff --git a/gen/src/fs.rs b/gen/src/fs.rs
index d1b0b70..77488f8 100644
--- a/gen/src/fs.rs
+++ b/gen/src/fs.rs
@@ -82,11 +82,12 @@ pub(crate) fn remove_file(path: impl AsRef<Path>) -> Result<()> {
     }
 }
 
-#[cfg(unix)]
-pub(crate) fn symlink(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Result<()> {
-    let src = src.as_ref();
-    let dst = dst.as_ref();
-    match std::os::unix::fs::symlink(src, dst) {
+fn symlink<'a>(
+    src: &'a Path,
+    dst: &'a Path,
+    fun: fn(&'a Path, &'a Path) -> io::Result<()>,
+) -> Result<()> {
+    match fun(src, dst) {
         Ok(()) => Ok(()),
         Err(e) => err!(
             e,
@@ -97,19 +98,31 @@ pub(crate) fn symlink(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Result<()
     }
 }
 
+#[cfg(unix)]
+#[allow(unused_imports)]
+pub(crate) use self::symlink_file as symlink_dir;
+
+#[cfg(unix)]
+pub(crate) fn symlink_file(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Result<()> {
+    symlink(src.as_ref(), dst.as_ref(), std::os::unix::fs::symlink)
+}
+
 #[cfg(windows)]
 pub(crate) fn symlink_file(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Result<()> {
-    let src = src.as_ref();
-    let dst = dst.as_ref();
-    match std::os::windows::fs::symlink_file(src, dst) {
-        Ok(()) => Ok(()),
-        Err(e) => err!(
-            e,
-            "Failed to create symlink `{}` pointing to `{}`",
-            dst,
-            src,
-        ),
-    }
+    symlink(
+        src.as_ref(),
+        dst.as_ref(),
+        std::os::windows::fs::symlink_file,
+    )
+}
+
+#[cfg(windows)]
+pub(crate) fn symlink_dir(src: impl AsRef<Path>, dst: impl AsRef<Path>) -> Result<()> {
+    symlink(
+        src.as_ref(),
+        dst.as_ref(),
+        std::os::windows::fs::symlink_dir,
+    )
 }
 
 pub(crate) fn write(path: impl AsRef<Path>, contents: impl AsRef<[u8]>) -> Result<()> {

